module decoder1(EN,A0,A1,D0,D1,D2,D3);
	input EN, A0, A1;
	output D0, D1, D2, D3;

	wire notA0, notA1, out0, out1, out2, out3;

	// unnamed gates, separated by commas
	not  (notA0,A0), (notA1,A1);

	// named gates, arranged for legibility
	and g0(out0,notA0,notA1),
		g1(out1,notA1,A0),
		g2(out2,A1,notA0),
		g3(out3,A1,A0);

	and (D0,out0,EN), (D1,out1,EN), (D2,out2,EN), (D3,out3,EN);
endmodule
